<script setup lang="ts">
    import { DemandeIntervention } from '@/interventionServiceOffer/entities/demandeIntervention/DemandeIntervention'
    import { DemandeInterventionApi } from '@/interventionServiceOffer/entities/demandeIntervention/DemandeInterventionApi'
    import { DemandeInterventionMapper } from '@/interventionServiceOffer/entities/demandeIntervention/DemandeInterventionMapper'
    import { Equipement } from '@/interventionServiceOffer/entities/equipement/Equipement'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { getAnalyticsProvider } from '@/shared/analytics/AnalyticsProvider'
    import {
        serviceOfferIdInjectionKey,
        serviceOfferTrackingCategoryInjectionKey,
    } from '@/shared/constants'
    import SImageCollectionEditor from '@/shared/document/components/SImageCollectionEditor.vue'
    import { requiredInject } from '@/shared/helpers/types'
    import {
        ComputedRef,
        computed,
        readonly,
        ref,
        toValue,
        watchEffect,
    } from 'vue'
    import SDemandeInterventionForm from './SDemandeInterventionForm.vue'
    import { interventionServiceOfferInjectionKey } from '@/interventionServiceOffer/constants'
    import { deepEquals } from '@/shared/helpers/objects'

    const interventionServiceOffer = requiredInject(
        interventionServiceOfferInjectionKey
    )

    interface Props {
        availableEquipements: Equipement[]
        isLoadingAvailableEquipements: boolean
        demandeOriginale?: Partial<DemandeIntervention>
        hiddenFields?: { [Property in keyof DemandeIntervention]?: true }
    }

    const props = withDefaults(defineProps<Props>(), {
        demandeOriginale: () => ({}),
        hiddenFields: undefined,
    })

    const valeuresParDefaut = computed<Partial<DemandeIntervention>>(() => ({
        relatedEquipement:
            props.availableEquipements.length === 1
                ? props.availableEquipements[0]
                : undefined,
        description:
            interventionServiceOffer.value?.data
                ?.modeleDeDescriptionPourDemandeIntervention,
    }))

    const demandeIntervention = ref<Partial<DemandeIntervention>>(
        mergeValeurParDefautEtDemandeInterventionsOrginale()
    )

    watchEffect(() => {
        demandeIntervention.value =
            mergeValeurParDefautEtDemandeInterventionsOrginale()
    })

    function mergeValeurParDefautEtDemandeInterventionsOrginale() {
        return {
            ...valeuresParDefaut.value,
            ...toValue(props.demandeOriginale),
        }
    }

    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const serviceOfferTrackingCategory = requiredInject(
        serviceOfferTrackingCategoryInjectionKey
    )

    const msal = useMsal()
    const demandeInterventionFormRef = ref<InstanceType<
        typeof SDemandeInterventionForm
    > | null>(null)

    const demandeInterventionApi = new DemandeInterventionApi(msal)

    const addedImagesB64 = ref<string[]>([])
    const formFieldsAreValid: ComputedRef<boolean> = computed(() => {
        return !!demandeInterventionFormRef.value?.formFieldsAreValid
    })
    const isProcessing = ref<boolean>(false)
    const isDirty = computed(() => {
        return !deepEquals(
            demandeIntervention.value,
            mergeValeurParDefautEtDemandeInterventionsOrginale()
        )
    })

    async function créerDemandeIntervention() {
        try {
            isProcessing.value = true
            const createdDemandeIntervention =
                await demandeInterventionApi.create(
                    serviceOfferId.value,
                    DemandeInterventionMapper.toCreateDto(
                        demandeIntervention.value
                    )
                )
            createdDemandeIntervention.images =
                await demandeInterventionApi.addImages(
                    serviceOfferId.value,
                    createdDemandeIntervention.id,
                    addedImagesB64.value
                )

            getAnalyticsProvider().sendEvent(
                serviceOfferTrackingCategory.value,
                "Demande d'intervention",
                `${createdDemandeIntervention.code} : ${createdDemandeIntervention.title}`
            )
            return createdDemandeIntervention
        } finally {
            isProcessing.value = false
        }
    }
    defineExpose({
        créerDemandeIntervention,
        formFieldsAreValid: readonly(formFieldsAreValid),
        isProcessing: readonly(isProcessing),
        isDirty: readonly(isDirty),
    })
</script>

<template>
    <v-row>
        <v-col cols="12">
            <s-image-collection-editor
                v-model:added-images-b64="addedImagesB64"
            />
        </v-col>

        <v-col cols="12">
            <s-demande-intervention-form
                ref="demandeInterventionFormRef"
                v-model="demandeIntervention"
                :available-equipements="availableEquipements"
                :is-loading-available-equipements="
                    isLoadingAvailableEquipements
                "
                :hidden-fields="hiddenFields"
            />
        </v-col>
    </v-row>
</template>
